
import javax.media.j3d.*;
import javax.vecmath.*;

import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.geometry.*;

public class BillboardExample extends BasicScene
{
  public static void main(String args[]){new BillboardExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    // Create the TransformGroup for the MouseRotate
    TransformGroup tg1 = new TransformGroup();
    tg1.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    root.addChild(tg1);
    
    tg1.addChild(new ColorCube(0.2));
    
    // Approximate infinite bounds
    BoundingSphere infiniteBounds = new BoundingSphere(new Point3d(), 
        Double.POSITIVE_INFINITY);
    
    // Create the MouseRotate behaviour
    MouseRotate rotate = new MouseRotate(tg1);
    rotate.setSchedulingBounds(infiniteBounds);
    tg1.addChild(rotate);
    
    // Create the TransformGroup for the translation
    Transform3D trans = new Transform3D();
    trans.setTranslation(new Vector3d(-0.5f, 0.0f, 0.0f));
    TransformGroup tg2 = new TransformGroup(trans);
    tg2.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    tg1.addChild(tg2);
   
    // Create the TransformGroup for use with the Billboard
    TransformGroup tg3 = new TransformGroup();
    tg3.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    tg2.addChild(tg3);
    
    tg3.addChild(new ColorCube(0.2));
    
    Billboard billboard = new Billboard(tg3, 
        Billboard.ROTATE_ABOUT_POINT, 
        new Point3f(0.0f, 0.0f, 0.0f));
    billboard.setSchedulingBounds(infiniteBounds);
    tg3.addChild(billboard);
    
    return root;
  }
}
