
import javax.media.j3d.*;
import javax.vecmath.*;

import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.geometry.*;

public class DistanceLODExample extends BasicScene
{
  public static void main(String args[]){new DistanceLODExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    // Create the TransformGroup that is to be updated
    TransformGroup tg = new TransformGroup();
    tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    root.addChild(tg);
    
    // Approximate infinite bounds
    BoundingSphere infiniteBounds = new BoundingSphere(new Point3d(), 
        Double.POSITIVE_INFINITY);
    
    // Create the MouseZoom behaviour
    MouseZoom zoom = new MouseZoom(tg);
    zoom.setSchedulingBounds(infiniteBounds);
    tg.addChild(zoom);
    
    // Create a Switch and enable write operations
    Switch sg = new Switch();
    sg.setCapability(Switch.ALLOW_SWITCH_WRITE);
    
    // Create a red sphere
    Appearance appRed = new Appearance();
    ColoringAttributes caRed = new ColoringAttributes(
        new Color3f(1.0f, 0.0f, 0.0f),
        ColoringAttributes.SHADE_FLAT);
    appRed.setColoringAttributes(caRed);
    Sphere sphereRed = new Sphere(0.4f, appRed);
    sg.addChild(sphereRed);
   
    // Create a green sphere
    Appearance appGreen = new Appearance();
    ColoringAttributes caGreen = new ColoringAttributes(
        new Color3f(0.0f, 1.0f, 0.0f),
        ColoringAttributes.SHADE_FLAT);
    appGreen.setColoringAttributes(caGreen);
    Sphere sphereGreen = new Sphere(0.4f, appGreen);
    sg.addChild(sphereGreen);
    
    // Create a blue sphere
    Appearance appBlue = new Appearance();
    ColoringAttributes caBlue = new ColoringAttributes(
        new Color3f(0.0f, 0.0f, 1.0f),
        ColoringAttributes.SHADE_FLAT);
    appBlue.setColoringAttributes(caBlue);
    Sphere sphereBlue = new Sphere(0.4f, appBlue);
    sg.addChild(sphereBlue);
    
    // Create DistanceLOD behaviour
    float[] distances = {4.0f, 8.0f}; 
    DistanceLOD lod = new DistanceLOD(distances);
    lod.setSchedulingBounds(infiniteBounds);
    lod.addSwitch(sg);
    
    tg.addChild(sg);
    tg.addChild(lod);
    
    return root;
  }
}
