
import java.awt.event.*;
import javax.media.j3d.*;

import com.sun.j3d.utils.picking.*;
import com.sun.j3d.utils.geometry.*;
import javax.vecmath.*;

public class PickExample extends BasicScene
{
  public static void main(String args[]){new PickExample();}
  
  PickCanvas pickCanvas;
  Appearance redAppearance;
  Appearance greenAppearance;
  Shape3D rightShape;
  Shape3D leftShape;
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    // Create and configure the PickCanvas
    pickCanvas = new PickCanvas(canvas, root);
    pickCanvas.setMode(PickTool.GEOMETRY); 
    pickCanvas.setTolerance(4.0f);
    
    // Create a red appearance
    redAppearance = new Appearance();
    ColoringAttributes red = new ColoringAttributes(
        new Color3f(1.0f, 0.0f, 0.0f),
        ColoringAttributes.SHADE_FLAT);
    redAppearance.setColoringAttributes(red);
    
    // Create a green appearance
    greenAppearance = new Appearance();
    ColoringAttributes green = new ColoringAttributes(
        new Color3f(0.0f, 1.0f, 0.0f),
        ColoringAttributes.SHADE_FLAT);
    greenAppearance.setColoringAttributes(green);
    
    // Create a TransformGroup whose children will be located 
    // 50 cm to the left of the origin
    Transform3D left = new Transform3D();
    left.setTranslation(new Vector3f(-0.5f, 0.0f, 0.0f));
    TransformGroup leftGroup = new TransformGroup(left);
    root.addChild(leftGroup);
    
    // Add a red sphere to the left TransformGroup
    Sphere leftSphere = new Sphere(0.2f, redAppearance);
    leftShape = leftSphere.getShape();
    leftShape.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
    leftGroup.addChild(leftSphere);
    
    // Create a TransformGroup whose children will be located
    // 50 cm to the right of the origin
    Transform3D right = new Transform3D();
    right.setTranslation(new Vector3f(0.5f, 0.0f, 0.0f));
    TransformGroup rightGroup = new TransformGroup(right);
    root.addChild(rightGroup);
    
    // Add a red sphere to the right TransformGroup
    Sphere rightSphere = new Sphere(0.2f, redAppearance);
    rightShape = rightSphere.getShape();
    rightShape.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
    rightGroup.addChild(rightSphere);
    
    return root;
  }
  
  public void mouseClicked(MouseEvent me) 
  {
    // Set the colour of both spheres to red
    leftShape.setAppearance(redAppearance);
    rightShape.setAppearance(redAppearance);
    
    // Get the picked nodes
    pickCanvas.setShapeLocation(me);
    PickResult[] results = pickCanvas.pickAll();
    
    if(results != null)
      for(int r=0; r<results.length; r++)
      {
        // Set the colour of the picked shape to green
        PickResult result = results[r]; 
        Shape3D sphere = (Shape3D)result.getObject();
        sphere.setAppearance(greenAppearance);
      }
  }
}
