
import javax.media.j3d.*;
import javax.vecmath.*;

import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.geometry.*;

public class PositionInterpolatorExample extends BasicScene
{
  public static void main(String args[]){new PositionInterpolatorExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    // Create the TransformGroup associated with the PositionInterpolator
    TransformGroup tg = new TransformGroup();
    tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    root.addChild(tg);
    
    // Add a ColorCube child
    tg.addChild(new ColorCube(0.2));
    
    // Create an alpha that will start after two seconds, loop four times 
    // where each loop lasts 1 second
    Alpha alpha = new Alpha(4, 1000);
    alpha.setTriggerTime(2000);
    
    // A Transform that rotates the x axis onto the y axis
    Transform3D transform = new Transform3D();
    transform.setRotation(new AxisAngle4f(0.0f, 0.0f, 1.0f, 
        (float)(Math.PI/2.0)));
    
    // Create the positional interpolator to move the ColorCube
    // between 0.0 and 0.5 on the y-axis
    PositionInterpolator pi = new PositionInterpolator(alpha,
        tg, transform, 0.0f, 0.5f);
    pi.setSchedulingBounds(new BoundingSphere(new Point3d(),
        Double.POSITIVE_INFINITY));
    tg.addChild(pi);
    
    return root;
  }
}
