
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.behaviors.interpolators.*;

public class TCBSplineExample extends BasicScene 
{
  public static void main(String args[]){new TCBSplineExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    TransformGroup tg = new TransformGroup();
    tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    root.addChild(tg);
    
    ColorCube colorCube = new ColorCube(0.1);
    tg.addChild(colorCube);
    
    TCBKeyFrame[] keyFrame = new TCBKeyFrame[5];
    
    // Create the first key frame at (0.5, 0.5)
    keyFrame[0] = new TCBKeyFrame(0.0f,
        0,
        new Point3f(0.5f,0.5f,0.0f),
        new Quat4f(0.0f, 0.0f, 0.0f, 0.0f),
        new Point3f(1.0f, 1.0f, 1.0f),
        0.0f, 0.0f, 0.0f);

    // Create the second key frame at (-0.5, 0.5)
    keyFrame[1] = new TCBKeyFrame(0.25f,
        0,
        new Point3f(-0.5f,0.5f,0.0f),
        new Quat4f(0.0f, 0.0f, 0.0f, 0.0f),
        new Point3f(1.0f, 1.0f, 1.0f),
        0.0f, 0.0f, 0.0f);
    

    // Create the thrid key frame at (-0.5, -0.5)
    keyFrame[2] = new TCBKeyFrame(0.50f,
        0,
        new Point3f(-0.5f,-0.5f,0.0f),
        new Quat4f(0.0f, 0.0f, 0.0f, 0.0f),
        new Point3f(1.0f, 1.0f, 1.0f),
        0.0f, 0.0f, 0.0f);
    

    // Create the fourth key frame at (0.5, -0.5)
    keyFrame[3] = new TCBKeyFrame(0.75f,
        0,
        new Point3f(0.5f,-0.5f,0.0f),
        new Quat4f(0.0f, 0.0f, 0.0f, 0.0f),
        new Point3f(1.0f, 1.0f, 1.0f),
        0.0f, 0.0f, 0.0f);
    

    // Create the final key frame at (0.0, 0.0)
    keyFrame[4] = new TCBKeyFrame(1.0f,
        0,
        new Point3f(0.0f,0.0f,0.0f),
        new Quat4f(0.0f, 0.0f, 0.0f, 0.0f), 
        new Point3f(1.0f, 1.0f, 1.0f),
        0.0f, 0.0f, 0.0f);

    // Create an Alpha that loops indefinitely for 
    // a duration of 4 seconds
    Alpha alpha = new Alpha(-1, 4000);
    
    // Create the TCB spline path interpolator
    RotPosScaleTCBSplinePathInterpolator i = 
      new RotPosScaleTCBSplinePathInterpolator(alpha, 
          tg, new Transform3D(),keyFrame);
    BoundingSphere s = new BoundingSphere(new Point3d(), 
        Double.POSITIVE_INFINITY);
    i.setSchedulingBounds(s);
    tg.addChild(i);
    
    return root;
  }
}
